type _ f =
  | I : 'a f -> (int->'a) f
  | S : 'a f -> (string->'a) f
  | L : string*'a f -> 'a f
  | N : unit f

let rec print_f : type a. a f -> a = function
  | I f -> fun i -> print_int i ; print_f f
  | S f -> fun s -> print_string s ; print_f f
  | L (s,f) -> print_string s ; print_f f
  | N -> ()

let () =
  print_f (I (S (I (L ("=", I N))))) 1 "+" 2 3 ;
  print_newline ()

type (_,_) fmt =
  | Int : (int -> 'a, 'a) fmt
  | String : (string -> 'a, 'a) fmt
  | Lit : string -> ('a,'a) fmt
  | Nop : ('a,'a) fmt
  | Concat : ('a,'b) fmt * ('b,'c) fmt -> ('a,'c) fmt

let rec print_fmt : type a b. (a,b) fmt -> (unit->b) -> a =
  fun fmt k -> match fmt with
  | Int -> fun i -> print_int i ; k ()
  | String -> fun s -> print_string s ; k ()
  | Lit s -> print_string s ; k ()
  | Nop -> k ()
  | Concat (f,g) -> print_fmt f (fun () -> print_fmt g k)

let () =
  print_fmt
    (Concat (Concat (Int, String), Concat (Int, Lit "=3")))
    (fun x -> x) 1 "+" 2 ;
  print_newline ()
